\chapter{Zwischenpr\"asentation}

\section{What have you completed since the last meeting?}
\begin{itemize}
	\item Repetition about Database architectures, SQL
	\item Read all papers (Datasette, SPARQL, Facebooks GraphQL, DBaaS)
	\item Create draft of docu in Latex
	\item Install PostgreSQL, PostGIS and hstore.
	\item Import schema and data (3 times)
	\item Run SQL queries directly on pgAdmin and benchmark. First on eosm (problems with queries, so I started with Sakila)
	\item us pgTune to improve performance, but no improvements seen
	\item Install PostgREST, setup web server and send benchmark queries.
	\item Try GraphQL with Heroku
	\item Install Docker and Hasura to send GraphQL queries.
\end{itemize}
	
\section{What is getting in your way?}
\begin{itemize}
	\item Translating all queries to postgREST and graphQL is often not possible and requires a lot of time.
	-> Dario creates the stored procedures for postgREST
	-> Marcel the queries for graphQL
	\item How to benchmark GraphQL queries in Hasura? Is a tool needed?
	-> use curl or directly in browser
\end{itemize}

\section{What do you plan to complete by the next meeting?}
\begin{itemize}
	\item Install and config gRPC, and translate queries. -> won't do
	\item Benchmark all Sql Queries -> done
	\item Translate all Queries to postgREST
	\item Translate all Queries to GraphQL
	\item Write Pro/Cons of each architecture style
	\item Vergleich mit OR/Mappers (Python-bezogen namentlich SQLAlchemy, Django und Qt's QSqlDatabase) -> will get removed
	\item Pro Anfragesprache, User Defined Types (UDT) austesten
	\item Weitere Anfragesprachen JOOQ und MongoDB -> will get removed
	\item Finish docu
	\item Prepare presentation (live demo)
\end{itemize}

\section{Questions}
Is it possible to reduce from two databases to one? -> remove specific queries, discuss with Dario.
Are there good benchmark tools? Multiple runs, average? -> no

pg pre warm to simulate cold start

\chapter{Presentation}
\begin{itemize}
	\item Titlepage - General - page 1
	
	\item Architectures
	\subitem Show overview - page 9
	\subitem Demo: Start postgres service - windows service
	\subitem Demo: pgTune - \url{https://pgtune.leopard.in.ua/}
	
	\item Datasette - Demo: open register germany - zund germany gmbh
	\url{https://db.offeneregister.de/openregister-ef9e802}\\
	\url{https://db.offeneregister.de/openregister-ef9e802?sql=select+*+from+company+where+name+like+%27%25Z%C3%BCnd%25%27+and+registered_address+like+%27%25Lindau%25%27}
	\begin{verbatim}
	select * from company where name like '%Zünd%' and registered_address like '%Lindau%'
	\end{verbatim}
	
	\item pgAdmin - Demo: pgAdmin eosm - zund eosm
	\begin{verbatim}
	select * from osm_polygon
	where osm_id = 415873259
	\end{verbatim}
	
	\item psql - Demo: sakila
	\begin{verbatim}
	git bash
	psql.exe --host=localhost --port=5432 --username=postgres -d sakila
	SELECT first_name, last_name
	FROM actor
	WHERE actor_id IN (
	SELECT actor_id
	FROM film_actor
	WHERE film_id IN (
	SELECT film_id
	FROM film
	WHERE title = 'Alone Trip'
	));
	\end{verbatim}
	
	\item PostgREST - Demo
	Start postgREST server
	\begin{verbatim}
	cd "C:/Program Files/PostgreSQL/11/bin"
	./postgrest.exe ../data/postgREST.conf
	\end{verbatim}
	Run a query
	\begin{verbatim}
	curl.exe http://localhost:3000/address?address_id=eq.605
	\end{verbatim}
	
	\item Hasura - GraphQL
	Then run the docker container with:
	\begin{verbatim}
	cd "C:/Git/Hasura"
	./docker-run.sh
	\end{verbatim}
	\url{http://localhost:8080/console}
	Send query 6e
	\begin{verbatim}
	{
	customer_aggregate(order_by: {last_name: asc}) {
	nodes {
	last_name
	first_name
	payments_aggregate {
	aggregate {
	sum {
	amount
	}}}}}}
	\end{verbatim}
	
\end{itemize}
